(function(){var P$=Clazz.newPackage("jalview.analysis"),I$=[[0,'jalview.datamodel.Point','StringBuilder','jalview.analysis.Connectivity','jalview.math.Matrix','jalview.analysis.ccAnalysis','jalview.bin.Console','java.io.PrintStream']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "PaSiMap", null, null, 'Runnable');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.dim=($b$[0] = 8, $b$[0]);
this.openCost=100;
this.extendCost=5;
this.cancelled=false;
},1);

C$.$fields$=[['Z',['cancelled','canCancel'],'B',['dim'],'I',['openCost','extendCost'],'O',['seqs','jalview.viewmodel.AlignmentViewport','scoreMatrix','jalview.analysis.scoremodels.ScoreMatrix','alignment','jalview.gui.PairwiseAlignPanel','pairwiseScores','jalview.math.MatrixI','+eigenMatrix']]]

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_api_analysis_ScoreModelI$jalview_gui_PairwiseAlignPanel',  function (sequences, sm, pap) {
;C$.$init$.apply(this);
this.seqs=sequences;
if (sm != null  && Clazz.instanceOf(sm, "jalview.analysis.scoremodels.ScoreMatrix") ) {
this.scoreMatrix=(sm);
} else {
this.scoreMatrix=null;
}this.alignment=pap;
}, 1);

Clazz.newMeth(C$, 'getEigenvalue$I',  function (i) {
return this.eigenMatrix.getD$()[i];
});

Clazz.newMeth(C$, 'getComponents$I$I$I$F',  function (l, n, mm, factor) {
var out=Clazz.array($I$(1), [this.getHeight$()]);
for (var i=0; i < out.length; i++) {
var x=this.component$I$I(i, l) * factor;
var y=this.component$I$I(i, n) * factor;
var z=this.component$I$I(i, mm) * factor;
out[i]=Clazz.new_($I$(1,1).c$$F$F$F,[x, y, z]);
}
return out;
});

Clazz.newMeth(C$, 'component$I',  function (n) {
var out=Clazz.array(Double.TYPE, [this.getWidth$()]);
for (var i=0; i < out.length; i++) {
out[i]=this.component$I$I(n, i);
}
return out;
});

Clazz.newMeth(C$, 'component$I$I',  function (row, n) {
return this.eigenMatrix.getValue$I$I(row, n);
});

Clazz.newMeth(C$, 'getDetails$',  function () {
var sb=Clazz.new_($I$(2,1).c$$I,[1024]);
sb.append$S("PaSiMap calculation using ").append$S(this.scoreMatrix.getName$()).append$S(" sequence similarity matrix\n========\n\n");
var ps=this.wrapOutputBuffer$StringBuilder(sb);
sb.append$S(" --- Pairwise correlation coefficients ---\n");
this.pairwiseScores.print$java_io_PrintStream$S(ps, "%8.6f ");
ps.println$();
sb.append$S(" --- Eigenvalues ---\n");
this.eigenMatrix.printD$java_io_PrintStream$S(ps, "%15.4e");
ps.println$();
sb.append$S(" --- Coordinates ---\n");
this.eigenMatrix.print$java_io_PrintStream$S(ps, "%8.6f ");
ps.println$();
return sb.toString();
});

Clazz.newMeth(C$, 'run$',  function () {
this.canCancel=true;
try {
this.alignment.calculate$jalview_analysis_scoremodels_ScoreMatrix(this.scoreMatrix);
if (this.alignment.isCancelled$()) {
this.cancel$();
return;
}var scores=this.alignment.getAlignmentScores$();
var iseqs=this.alignment.getInputSequences$();
$I$(3).getConnectivity$jalview_datamodel_SequenceIA$FAA$B(iseqs, scores, 8);
this.canCancel=false;
this.alignment.updateProgress$S$S("message_in_progress", "Creating the PaSiMap");
this.pairwiseScores=Clazz.new_($I$(4,1).c$$FAA,[scores]);
this.pairwiseScores.fillDiagonal$();
this.eigenMatrix=this.pairwiseScores.copy$();
var cc=Clazz.new_($I$(5,1).c$$jalview_math_MatrixI$B,[this.pairwiseScores, 8]);
this.eigenMatrix=cc.run$().mirrorCol$();
this.alignment.updateProgress$S$S("finished_stop_progress", "Finished PaSiMap.");
} catch (q) {
if (Clazz.exceptionOf(q,"Exception")){
$I$(6,"error$S",["Error computing PaSiMap:  " + q.getMessage$()]);
q.printStackTrace$();
} else {
throw q;
}
}
});

Clazz.newMeth(C$, 'cancel$',  function () {
if (this.alignment != null ) {
this.alignment.cancel$();
}this.cancelled=true;
});

Clazz.newMeth(C$, 'isCancelled$',  function () {
return this.cancelled;
});

Clazz.newMeth(C$, 'wrapOutputBuffer$StringBuilder',  function (sb) {
var ps=((P$.PaSiMap$1||
(function(){/*a*/var C$=Clazz.newClass(P$, "PaSiMap$1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, Clazz.load('java.io.PrintStream'), null, 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

Clazz.newMeth(C$, 'print$S',  function (x) {
this.$finals$.sb.append$S(x);
});

Clazz.newMeth(C$, 'println$',  function () {
this.$finals$.sb.append$S("\n");
});
})()
), Clazz.new_($I$(7,1).c$$java_io_OutputStream,[this, {sb:sb}, System.out],P$.PaSiMap$1));
return ps;
});

Clazz.newMeth(C$, 'getHeight$',  function () {
return this.eigenMatrix.height$();
});

Clazz.newMeth(C$, 'getWidth$',  function () {
return this.eigenMatrix.width$();
});

Clazz.newMeth(C$, 'getPairwiseScores$',  function () {
return this.pairwiseScores;
});

Clazz.newMeth(C$, 'setPairwiseScores$jalview_math_MatrixI',  function (m) {
this.pairwiseScores=m;
});

Clazz.newMeth(C$, 'getEigenmatrix$',  function () {
return this.eigenMatrix;
});

Clazz.newMeth(C$, 'setEigenmatrix$jalview_math_MatrixI',  function (m) {
this.eigenMatrix=m;
});

Clazz.newMeth(C$, 'getAlignments$',  function () {
return this.alignment;
});

Clazz.newMeth(C$, 'getAlignmentOutput$',  function () {
return this.alignment.getAlignmentOutput$();
});

Clazz.newMeth(C$, 'getDim$',  function () {
return 8;
});

Clazz.newMeth(C$, 'isCancellable$',  function () {
return this.canCancel;
});
var $b$ = new Int8Array(1);

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:44 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
