(function(){var P$=Clazz.newPackage("jalview.bin.argparser"),p$1={},I$=[[0,'java.util.HashMap','java.util.HashSet','java.util.ArrayList','java.util.Arrays','jalview.bin.Console','jalview.bin.argparser.ArgParser',['jalview.bin.argparser.Arg','.Opt'],['jalview.bin.argparser.Arg','.Type'],'java.util.Locale','java.util.EnumSet','jalview.bin.argparser.Arg','jalview.util.FileUtils','java.io.File','java.util.stream.Collectors',['java.util.AbstractMap','.SimpleEntry']]],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "BootstrapArgs");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.bootstrapArgMap=Clazz.new_($I$(1,1));
this.argFiles=Clazz.new_($I$(2,1));
this.argsOptions=Clazz.new_($I$(2,1));
this.argsTypes=Clazz.new_($I$(2,1));
this.outputToStdout=false;
},1);

C$.$fields$=[['Z',['outputToStdout'],'O',['bootstrapArgMap','java.util.Map','argFiles','java.util.Set','+argsOptions','+argsTypes']]]

Clazz.newMeth(C$, 'getBootstrapArgs$SA',  function (args) {
var argList=Clazz.new_([$I$(4).asList$OA(args)],$I$(3,1).c$$java_util_Collection);
return Clazz.new_(C$.c$$java_util_List,[argList]);
}, 1);

Clazz.newMeth(C$, 'getBootstrapArgs$java_util_List',  function (args) {
return Clazz.new_(C$.c$$java_util_List,[args]);
}, 1);

Clazz.newMeth(C$, 'c$$java_util_List',  function (args) {
;C$.$init$.apply(this);
p$1.parse$java_util_List$java_io_File.apply(this, [args, null]);
}, 1);

Clazz.newMeth(C$, 'parse$java_util_List$java_io_File',  function (args, inArgFile) {
if (args == null ) return;
if (inArgFile != null ) {
if (this.argFiles.contains$O(inArgFile)) {
$I$(5,"errPrintln$O",["Looped argfiles detected: '" + inArgFile.getPath$() + "'" ]);
return;
}this.argFiles.add$O(inArgFile);
}for (var i=0; i < args.size$(); i++) {
var arg=args.get$I(i);
if (arg.startsWith$S("--")) {
var argName=null;
var val=null;
var type=null;
argName=arg.substring$I("--".length$());
var equalPos=argName.indexOf$I("=");
if (equalPos > -1) {
val=argName.substring$I(equalPos + 1);
argName=argName.substring$I$I(0, equalPos);
}if (argName.startsWith$S("no") && $I$(6).argMap.containsKey$O(argName.substring$I("no".length$())) ) {
val="false";
argName=argName.substring$I("no".length$());
}var dashPos=argName.indexOf$S("-");
if (dashPos > -1) {
var potentialArgName=argName.substring$I$I(0, dashPos);
var potentialArg=$I$(6).argMap.get$O(potentialArgName);
if (potentialArg != null  && potentialArg.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).HASTYPE) ) {
var typeName=argName.substring$I(dashPos + 1);
try {
type=$I$(8,"valueOf$S",[typeName.toUpperCase$java_util_Locale($I$(9).ROOT)]);
} catch (e) {
if (Clazz.exceptionOf(e,"IllegalArgumentException")){
type=$I$(8).INVALID;
} else {
throw e;
}
}
argName=argName.substring$I$I(0, dashPos);
}}if (!$I$(6).argMap.containsKey$O(argName)) {
for (var potentialArg, $potentialArg = $I$(10,"allOf$Class",[Clazz.getClass($I$(11))]).iterator$(); $potentialArg.hasNext$()&&((potentialArg=($potentialArg.next$())),1);) {
if (potentialArg.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).PREFIXKEV) && argName != null   && argName.startsWith$S(potentialArg.getName$())  && val != null  ) {
val=argName.substring$I(potentialArg.getName$().length$()) + "=" + val ;
argName=argName.substring$I$I(0, potentialArg.getName$().length$());
break;
}}
}var a=$I$(6).argMap.get$O(argName);
if (a != null ) {
for (var opt, $opt = 0, $$opt = a.getOptions$(); $opt<$$opt.length&&((opt=($$opt[$opt])),1);$opt++) {
if (!this.argsOptions.contains$O(opt)) {
this.argsOptions.add$O(opt);
}}
for (var t, $t = 0, $$t = a.getTypes$(); $t<$$t.length&&((t=($$t[$t])),1);$t++) {
if (!this.argsTypes.contains$O(t)) {
this.argsTypes.add$O(t);
}}
}if (a == null  || !a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).BOOTSTRAP) ) {
if (a != null  && a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).OUTPUTFILE)  && a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).STDOUT) ) {
if (val == null  && i + 1 < args.size$() ) {
val=args.get$I(i + 1);
}if (val.startsWith$S("[") && val.indexOf$I("]") > 0 ) {
val=val.substring$I(val.indexOf$I("]") + 1);
}if ("-".equals$O(val)) {
this.outputToStdout=true;
}}continue;
}if (a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).STRING)) {
var vals=null;
if (equalPos == -1) {
vals=$I$(6).getShellGlobbedFilenameValues$jalview_bin_argparser_Arg$java_util_List$I(a, args, i + 1);
} else {
if (a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).GLOB)) {
vals=$I$(12).getFilenamesFromGlob$S(val);
} else {
vals=Clazz.new_($I$(3,1));
vals.add$O(val);
}}p$1.addAll$jalview_bin_argparser_Arg$jalview_bin_argparser_Arg_Type$java_util_List.apply(this, [a, type, vals]);
if (a === $I$(11).ARGFILE ) {
for (var filename, $filename = vals.iterator$(); $filename.hasNext$()&&((filename=($filename.next$())),1);) {
var argFile=Clazz.new_($I$(13,1).c$$S,[filename]);
p$1.parse$java_util_List$java_io_File.apply(this, [$I$(6).readArgFile$java_io_File(argFile), argFile]);
}
}} else {
if (val == null ) {
val="true";
}p$1.add$jalview_bin_argparser_Arg$jalview_bin_argparser_Arg_Type$S.apply(this, [a, type, val]);
}}}
if (inArgFile != null ) {
this.argFiles.remove$O(inArgFile);
}}, p$1);

Clazz.newMeth(C$, 'contains$jalview_bin_argparser_Arg',  function (a) {
return this.bootstrapArgMap.containsKey$O(a);
});

Clazz.newMeth(C$, 'containsType$jalview_bin_argparser_Arg_Type',  function (t) {
for (var l, $l = this.bootstrapArgMap.values$().iterator$(); $l.hasNext$()&&((l=($l.next$())),1);) {
for (var e, $e = l.iterator$(); $e.hasNext$()&&((e=($e.next$())),1);) {
if (e.getKey$() === t ) return true;
}
}
return false;
});

Clazz.newMeth(C$, 'getArgsOfType$jalview_bin_argparser_Arg_Type',  function (t) {
return this.getArgsOfType$jalview_bin_argparser_Arg_Type$jalview_bin_argparser_Arg_OptA(t, Clazz.array($I$(7), -1, []));
});

Clazz.newMeth(C$, 'getArgsOfType$jalview_bin_argparser_Arg_Type$jalview_bin_argparser_Arg_OptA',  function (t, opts) {
var args=Clazz.new_($I$(3,1));
for (var a, $a = this.bootstrapArgMap.keySet$().iterator$(); $a.hasNext$()&&((a=($a.next$())),1);) {
if (!a.hasAllOptions$jalview_bin_argparser_Arg_OptA(opts)) continue;
var l=this.bootstrapArgMap.get$O(a);
if (l.stream$().anyMatch$java_util_function_Predicate(((P$.BootstrapArgs$lambda1||
(function(){/*m*/var C$=Clazz.newClass(P$, "BootstrapArgs$lambda1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, null, 'java.util.function.Predicate', 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);
/*lambda_E*/
Clazz.newMeth(C$, ['test$java_util_Map_Entry','test$O'],  function (e) { return (e.getKey$() === this.$finals$.t );});
})()
), Clazz.new_(P$.BootstrapArgs$lambda1.$init$,[this, {t:t}])))) {
args.add$O(a);
}}
return args;
});

Clazz.newMeth(C$, 'getList$jalview_bin_argparser_Arg',  function (a) {
return this.bootstrapArgMap.get$O(a);
});

Clazz.newMeth(C$, 'getValueList$jalview_bin_argparser_Arg',  function (a) {
return this.bootstrapArgMap.get$O(a).stream$().map$java_util_function_Function((P$.BootstrapArgs$lambda2$||(P$.BootstrapArgs$lambda2$=(((P$.BootstrapArgs$lambda2||
(function(){/*m*/var C$=Clazz.newClass(P$, "BootstrapArgs$lambda2", function(){Clazz.newInstance(this, arguments[0],1,C$);}, null, 'java.util.function.Function', 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);
/*lambda_E*/
Clazz.newMeth(C$, ['apply$java_util_Map_Entry','apply$O'],  function (e) { return (e.getValue$());});
})()
), Clazz.new_(P$.BootstrapArgs$lambda2.$init$,[this, null])))))).collect$java_util_stream_Collector($I$(14).toList$());
});

Clazz.newMeth(C$, 'getOrCreateList$jalview_bin_argparser_Arg',  function (a) {
var l=this.getList$jalview_bin_argparser_Arg(a);
if (l == null ) {
l=Clazz.new_($I$(3,1));
p$1.putList$jalview_bin_argparser_Arg$java_util_List.apply(this, [a, l]);
}return l;
}, p$1);

Clazz.newMeth(C$, 'putList$jalview_bin_argparser_Arg$java_util_List',  function (a, l) {
this.bootstrapArgMap.put$O$O(a, l);
}, p$1);

Clazz.newMeth(C$, 'add$jalview_bin_argparser_Arg$jalview_bin_argparser_Arg_Type$S',  function (a, t, s) {
var l=p$1.getOrCreateList$jalview_bin_argparser_Arg.apply(this, [a]);
if (a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).MULTIVALUE) || l.size$() == 0 ) {
l.add$O(C$.entry$jalview_bin_argparser_Arg_Type$S(t, s));
}}, p$1);

Clazz.newMeth(C$, 'addAll$jalview_bin_argparser_Arg$jalview_bin_argparser_Arg_Type$java_util_List',  function (a, t, al) {
var l=p$1.getOrCreateList$jalview_bin_argparser_Arg.apply(this, [a]);
if (a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).MULTIVALUE)) {
for (var s, $s = al.iterator$(); $s.hasNext$()&&((s=($s.next$())),1);) {
l.add$O(C$.entry$jalview_bin_argparser_Arg_Type$S(t, s));
}
} else if (l.size$() == 0 && al.size$() > 0 ) {
l.add$O(C$.entry$jalview_bin_argparser_Arg_Type$S(t, al.get$I(0)));
}}, p$1);

Clazz.newMeth(C$, 'entry$jalview_bin_argparser_Arg_Type$S',  function (t, s) {
return Clazz.new_($I$(15,1).c$$O$O,[t, s]);
}, 1);

Clazz.newMeth(C$, 'getValue$jalview_bin_argparser_Arg',  function (a) {
if (!this.bootstrapArgMap.containsKey$O(a)) return null;
var aL=this.bootstrapArgMap.get$O(a);
return (aL == null  || aL.size$() == 0 ) ? null : aL.get$I(0).getValue$();
});

Clazz.newMeth(C$, 'getBoolean$jalview_bin_argparser_Arg$Z',  function (a, d) {
if (!this.bootstrapArgMap.containsKey$O(a)) return d;
return Boolean.parseBoolean$S(this.getValue$jalview_bin_argparser_Arg(a));
});

Clazz.newMeth(C$, 'getBoolean$jalview_bin_argparser_Arg',  function (a) {
if (!(a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).BOOLEAN) || a.hasOption$jalview_bin_argparser_Arg_Opt($I$(7).UNARY) )) {
return false;
}if (this.bootstrapArgMap.containsKey$O(a)) {
return Boolean.parseBoolean$S(this.getValue$jalview_bin_argparser_Arg(a));
} else {
return a.getDefaultBoolValue$();
}});

Clazz.newMeth(C$, 'argsHaveOption$jalview_bin_argparser_Arg_Opt',  function (opt) {
return this.argsOptions.contains$O(opt);
});

Clazz.newMeth(C$, 'argsHaveType$jalview_bin_argparser_Arg_Type',  function (type) {
return this.argsTypes.contains$O(type);
});

Clazz.newMeth(C$, 'isHeadless$',  function () {
var isHeadless=false;
if (this.argsHaveType$jalview_bin_argparser_Arg_Type($I$(8).HELP)) {
isHeadless=true;
} else if (this.contains$jalview_bin_argparser_Arg($I$(11).VERSION)) {
isHeadless=true;
} else if (this.contains$jalview_bin_argparser_Arg($I$(11).GUI)) {
isHeadless=!this.getBoolean$jalview_bin_argparser_Arg($I$(11).GUI);
} else if (this.contains$jalview_bin_argparser_Arg($I$(11).HEADLESS)) {
isHeadless=this.getBoolean$jalview_bin_argparser_Arg($I$(11).HEADLESS);
} else if (this.argsHaveOption$jalview_bin_argparser_Arg_Opt($I$(7).OUTPUTFILE)) {
isHeadless=true;
}return isHeadless;
});

Clazz.newMeth(C$, 'outputToStdout$',  function () {
return this.outputToStdout;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:50 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
