(function(){var P$=Clazz.newPackage("jalview.analysis"),I$=[[0,'java.util.Vector','jalview.math.Matrix','java.util.BitSet','jalview.datamodel.BinaryNode','java.util.ArrayList']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "AverageDistanceEngine", null, 'jalview.analysis.TreeEngine');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.mode=1;
},1);

C$.$fields$=[['I',['mode'],'O',['cm','jalview.datamodel.ContactMatrixI','av','jalview.viewmodel.AlignmentViewport','aa','jalview.datamodel.AlignmentAnnotation']]]

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_AlignmentAnnotation$jalview_datamodel_ContactMatrixI$Z',  function (av, aa, cm, cosineOrDifference) {
Clazz.super_(C$, this);
this.av=av;
this.aa=aa;
this.cm=cm;
this.mode=(cosineOrDifference) ? 1 : 0;
this.calculate$jalview_datamodel_ContactMatrixI(cm);
}, 1);

Clazz.newMeth(C$, 'calculate$jalview_datamodel_ContactMatrixI',  function (cm) {
this.cm=cm;
this.node=Clazz.new_($I$(1,1));
this.clusters=Clazz.new_($I$(1,1));
this.distances=Clazz.new_([Clazz.array(Double.TYPE, [cm.getWidth$(), cm.getWidth$()])],$I$(2,1).c$$DAA);
this.noseqs=cm.getWidth$();
this.done=Clazz.new_($I$(3,1));
var moduli=Clazz.array(Double.TYPE, [cm.getWidth$()]);
var max;
if (this.mode == 0) {
max=1;
} else {
max=cm.getMax$() * cm.getMax$();
}for (var i=0; i < cm.getWidth$(); i++) {
var cnode=Clazz.new_($I$(4,1));
cnode.setElement$O(Integer.valueOf$I(i));
cnode.setName$S("c" + i);
this.node.addElement$O(cnode);
var bs=Clazz.new_($I$(3,1));
bs.set$I(i);
this.clusters.addElement$O(bs);
var ith=cm.getContactList$I(i);
this.distances.setValue$I$I$D(i, i, 0);
if (ith == null ) {
continue;
}for (var j=0; j < i; j++) {
var jth=cm.getContactList$I(j);
if (jth == null ) {
break;
}var prd=0;
for (var indx=0; indx < cm.getHeight$(); indx++) {
if (this.mode == 0) {
if (j == 0) {
moduli[i]+=ith.getContactAt$I(indx) * ith.getContactAt$I(indx);
}prd+=ith.getContactAt$I(indx) * jth.getContactAt$I(indx);
} else {
prd+=Math.abs(ith.getContactAt$I(indx) - jth.getContactAt$I(indx));
}}
if (this.mode == 0) {
if (j == 0) {
moduli[i]=Math.sqrt(moduli[i]);
}prd=(moduli[i] != 0  && moduli[j] != 0  ) ? prd / (moduli[i] * moduli[j]) : 0;
prd=1 - prd;
} else {
prd/=cm.getHeight$();
}this.distances.setValue$I$I$D(i, j, prd);
this.distances.setValue$I$I$D(j, i, prd);
}
}
this.noClus=this.clusters.size$();
this.cluster$();
});

Clazz.newMeth(C$, 'findClusterDistance$I$I',  function (i, j) {
var noi=this.clusters.elementAt$I(i).cardinality$();
var noj=this.clusters.elementAt$I(j).cardinality$();
var newdist=Clazz.array(Double.TYPE, [this.noseqs]);
for (var l=0; l < this.noseqs; l++) {
if ((l != i) && (l != j) ) {
newdist[l]=((this.distances.getValue$I$I(i, l) * noi) + (this.distances.getValue$I$I(j, l) * noj)) / (noi + noj);
} else {
newdist[l]=0;
}}
for (var ii=0; ii < this.noseqs; ii++) {
this.distances.setValue$I$I$D(i, ii, newdist[ii]);
this.distances.setValue$I$I$D(ii, i, newdist[ii]);
}
});

Clazz.newMeth(C$, 'findMinDistance$',  function () {
var min=1.7976931348623157E308;
for (var i=0; i < (this.noseqs - 1); i++) {
for (var j=i + 1; j < this.noseqs; j++) {
if (!this.done.get$I(i) && !this.done.get$I(j) ) {
if (this.distances.getValue$I$I(i, j) < min ) {
this.mini=i;
this.minj=j;
min=this.distances.getValue$I$I(i, j);
}}}
}
return min;
});

Clazz.newMeth(C$, 'findNewDistances$jalview_datamodel_BinaryNode$jalview_datamodel_BinaryNode$D',  function (nodei, nodej, dist) {
var ih=0;
var jh=0;
var sni=nodei;
var snj=nodej;
while (sni != null ){
ih=ih + sni.dist;
sni=sni.left$();
}
while (snj != null ){
jh=jh + snj.dist;
snj=snj.left$();
}
nodei.dist=((dist / 2) - ih);
nodej.dist=((dist / 2) - jh);
});

Clazz.newMeth(C$, 'groupNodes$F',  function (threshold) {
var groups=Clazz.new_($I$(5,1));
this._groupNodes$java_util_List$jalview_datamodel_BinaryNode$F(groups, this.getTopNode$(), threshold);
return groups;
});

Clazz.newMeth(C$, '_groupNodes$java_util_List$jalview_datamodel_BinaryNode$F',  function (groups, nd, threshold) {
if (nd == null ) {
return;
}if ((nd.height / this.maxheight) > threshold ) {
groups.add$O(nd);
} else {
this._groupNodes$java_util_List$jalview_datamodel_BinaryNode$F(groups, nd.left$(), threshold);
this._groupNodes$java_util_List$jalview_datamodel_BinaryNode$F(groups, nd.right$(), threshold);
}});

Clazz.newMeth(C$, 'findHeight$jalview_datamodel_BinaryNode',  function (nd) {
if (nd == null ) {
return this.maxheight;
}if ((nd.left$() == null ) && (nd.right$() == null ) ) {
nd.height=(nd.parent$()).height + nd.dist;
if (nd.height > this.maxheight ) {
return nd.height;
} else {
return this.maxheight;
}} else {
if (nd.parent$() != null ) {
nd.height=(nd.parent$()).height + nd.dist;
} else {
this.maxheight=0;
nd.height=0.0;
}this.maxheight=this.findHeight$jalview_datamodel_BinaryNode((nd.left$()));
this.maxheight=this.findHeight$jalview_datamodel_BinaryNode((nd.right$()));
}return this.maxheight;
});

Clazz.newMeth(C$, 'findLeaves$jalview_datamodel_BinaryNode',  function (top2) {
var leaves=Clazz.new_($I$(1,1));
this.findLeaves$jalview_datamodel_BinaryNode$java_util_Vector(top2, leaves);
return leaves;
});

Clazz.newMeth(C$, 'findLeaves$jalview_datamodel_BinaryNode$java_util_Vector',  function (nd, leaves) {
if (nd == null ) {
return leaves;
}if ((nd.left$() == null ) && (nd.right$() == null ) ) {
leaves.addElement$O(nd);
return leaves;
} else {
this.findLeaves$jalview_datamodel_BinaryNode$java_util_Vector(nd.left$(), leaves);
this.findLeaves$jalview_datamodel_BinaryNode$java_util_Vector(nd.right$(), leaves);
}return leaves;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:44 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
