(function(){var P$=Clazz.newPackage("jalview.analysis"),I$=[[0,'java.util.Vector','jalview.datamodel.SeqCigar','jalview.datamodel.CigarArray','jalview.datamodel.AlignmentView','java.util.BitSet','jalview.datamodel.SequenceNode']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "TreeBuilder", null, 'jalview.analysis.TreeEngine');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['O',['sequences','jalview.datamodel.SequenceI[]','seqData','jalview.datamodel.AlignmentView','+seqStrings']]]

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_api_analysis_ScoreModelI$jalview_api_analysis_SimilarityParamsI',  function (av, sm, scoreParameters) {
Clazz.super_(C$, this);
var start;
var end;
var selview=av.getSelectionGroup$() != null  && av.getSelectionGroup$().getSize$() > 1 ;
this.seqStrings=av.getAlignmentView$Z(selview);
if (!selview) {
start=0;
end=av.getAlignment$().getWidth$();
this.sequences=av.getAlignment$().getSequencesArray$();
} else {
start=av.getSelectionGroup$().getStartRes$();
end=av.getSelectionGroup$().getEndRes$() + 1;
this.sequences=av.getSelectionGroup$().getSequencesInOrder$jalview_datamodel_AlignmentI(av.getAlignment$());
}this.init$jalview_datamodel_AlignmentView$I$I(this.seqStrings, start, end);
this.computeTree$jalview_api_analysis_ScoreModelI$jalview_api_analysis_SimilarityParamsI(sm, scoreParameters);
}, 1);

Clazz.newMeth(C$, 'getSequences$',  function () {
return this.sequences;
});

Clazz.newMeth(C$, 'hasDistances$',  function () {
return true;
});

Clazz.newMeth(C$, 'hasBootstrap$',  function () {
return false;
});

Clazz.newMeth(C$, 'hasRootDistance$',  function () {
return true;
});

Clazz.newMeth(C$, 'computeTree$jalview_api_analysis_ScoreModelI$jalview_api_analysis_SimilarityParamsI',  function (sm, scoreOptions) {
this.distances=sm.findDistances$jalview_datamodel_AlignmentView$jalview_api_analysis_SimilarityParamsI(this.seqData, scoreOptions);
this.makeLeaves$();
this.noClus=this.clusters.size$();
this.cluster$();
});

Clazz.newMeth(C$, 'init$jalview_datamodel_AlignmentView$I$I',  function (seqView, start, end) {
this.node=Clazz.new_($I$(1,1));
if (seqView != null ) {
this.seqData=seqView;
} else {
var seqs=Clazz.array($I$(2), [this.sequences.length]);
for (var i=0; i < this.sequences.length; i++) {
seqs[i]=Clazz.new_($I$(2,1).c$$jalview_datamodel_SequenceI$I$I,[this.sequences[i], start, end]);
}
var sdata=Clazz.new_($I$(3,1).c$$jalview_datamodel_CigarSimpleA,[seqs]);
sdata.addOperation$C$I("M", end - start + 1);
this.seqData=Clazz.new_($I$(4,1).c$$jalview_datamodel_CigarArray$I,[sdata, start]);
}this.noseqs=0;
this.done=Clazz.new_($I$(5,1));
for (var seq, $seq = 0, $$seq = this.sequences; $seq<$$seq.length&&((seq=($$seq[$seq])),1);$seq++) {
if (seq != null ) {
++this.noseqs;
}}
});

Clazz.newMeth(C$, 'makeLeaves$',  function () {
this.clusters=Clazz.new_($I$(1,1));
for (var i=0; i < this.noseqs; i++) {
var sn=Clazz.new_($I$(6,1));
sn.setElement$O(this.sequences[i]);
sn.setName$S(this.sequences[i].getName$());
this.node.addElement$O(sn);
var bs=Clazz.new_($I$(5,1));
bs.set$I(i);
this.clusters.addElement$O(bs);
}
});

Clazz.newMeth(C$, 'getOriginalData$',  function () {
return this.seqStrings;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:44 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
