(function(){var P$=Clazz.newPackage("jalview.datamodel"),p$1={},I$=[[0,'Error','java.util.ArrayList','jalview.datamodel.ContactListImpl','StringBuilder','java.util.StringTokenizer','jalview.bin.Console']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "ContactMatrix", null, 'jalview.datamodel.GroupSetHolder', 'jalview.datamodel.ContactMatrixI');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.symmetric=true;
this.contacts=null;
this.width=0;
this.numcontacts=0;
this.min=0.0;
this.max=0.0;
},1);

C$.$fields$=[['Z',['symmetric'],'F',['min','max'],'I',['width','numcontacts'],'O',['contacts','java.util.List']]]

Clazz.newMeth(C$, 'c$$Z',  function (symmetric) {
Clazz.super_(C$, this);
this.symmetric=symmetric;
}, 1);

Clazz.newMeth(C$, 'addContact$I$I$F',  function (left, right, strength) {
if (left < 0 || right < 0 ) {
throw Clazz.new_([Clazz.new_(Clazz.load('RuntimeException').c$$S,["Cannot have negative indices for contact left=" + left + " right=" + right + " strength=" + new Float(strength).toString() ])],$I$(1,1).c$$Throwable);
}if (this.symmetric) {
if (left > right) {
var r=right;
right=left;
left=r;
}}if (this.contacts == null ) {
this.contacts=Clazz.new_($I$(2,1));
}var clist=this.contacts.get$I(left);
if (clist == null ) {
clist=Clazz.new_($I$(2,1));
this.contacts.set$I$O(left, clist);
}var last=clist.set$I$O(right, Float.valueOf$F(strength));
p$1.checkBounds$F.apply(this, [strength]);
if (last == null ) {
++this.numcontacts;
}});

Clazz.newMeth(C$, 'checkBounds$F',  function (strength) {
if (this.min > strength ) {
this.min=strength;
}if (this.max < strength ) {
this.max=strength;
}}, p$1);

Clazz.newMeth(C$, 'getContactList$I',  function (column) {
if (column < 0 || column >= this.width ) {
return null;
}return Clazz.new_([((P$.ContactMatrix$1||
(function(){/*a*/var C$=Clazz.newClass(P$, "ContactMatrix$1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, null, 'jalview.datamodel.ContactListProviderI', 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.p=column;
},1);

C$.$fields$=[['I',['p']]]

Clazz.newMeth(C$, 'getPosition$',  function () {
return this.p;
});

Clazz.newMeth(C$, 'getContactHeight$',  function () {
return this.b$['jalview.datamodel.ContactMatrix'].width;
});

Clazz.newMeth(C$, 'getContactAt$I',  function (column) {
var cl=p$1.getFloatElementAt$I$I.apply(this.b$['jalview.datamodel.ContactMatrix'], [column, this.p]);
if (cl == null ) {
return NaN;
}return cl.doubleValue$();
});
})()
), Clazz.new_(P$.ContactMatrix$1.$init$,[this, null]))],$I$(3,1).c$$jalview_datamodel_ContactListProviderI);
});

Clazz.newMeth(C$, 'getFloatElementAt$I$I',  function (column, p) {
var clist;
var cl=null;
if (this.symmetric) {
if (p < column) {
clist=this.contacts.get$I(p);
cl=clist.get$I(column);
} else {
clist=this.contacts.get$I(column);
cl=clist.get$I(p);
}} else {
clist=this.contacts.get$I(p);
cl=clist.get$I(column);
}return cl;
}, p$1);

Clazz.newMeth(C$, 'getElementAt$I$I',  function (column, row) {
var cl=p$1.getFloatElementAt$I$I.apply(this, [column, row]);
if (cl != null ) {
return (cl).valueOf();
}throw (Clazz.new_(Clazz.load('RuntimeException').c$$S,["Out of Bounds " + column + "," + row ]));
});

Clazz.newMeth(C$, 'getMin$',  function () {
return this.min;
});

Clazz.newMeth(C$, 'getMax$',  function () {
return this.max;
});

Clazz.newMeth(C$, 'getAnnotLabel$',  function () {
return "Contact Matrix";
});

Clazz.newMeth(C$, 'getAnnotDescr$',  function () {
return "Contact Matrix";
});

Clazz.newMeth(C$, 'contactToFloatString$jalview_datamodel_ContactMatrixI',  function (cm) {
var sb=Clazz.new_($I$(4,1));
for (var c=0; c < cm.getWidth$(); c++) {
var cl=cm.getContactList$I(c);
var lastsb=-1;
if (cl != null ) {
for (var h=0; h <= cl.getContactHeight$(); h++) {
if (sb.length$() > 0) {
if (Long.$gt(Long.$sub(sb.length$(),lastsb),320 )) {
sb.append$C("\n");
lastsb=sb.length$();
} else {
sb.append$C("\t");
}}sb.append$D(cl.getContactAt$I(h));
}
}}
return sb.toString();
}, 1);

Clazz.newMeth(C$, 'fromFloatStringToContacts$S$I$I',  function (values, cols, rows) {
var vals=Clazz.array(Float.TYPE, [cols, rows]);
var tabsep=Clazz.new_($I$(5,1).c$$S$S,[values, "\t\n"]);
var c=0;
var r=0;
while (tabsep.hasMoreTokens$()){
var elem=(Double.valueOf$S(tabsep.nextToken$())).valueOf();
vals[c][r++]=elem;
if (r >= vals[c].length) {
r=0;
++c;
}if (c >= vals.length) {
break;
}}
if (tabsep.hasMoreElements$()) {
$I$(6).warn$S("Ignoring additional elements for Float string to contact matrix parsing.");
}return vals;
}, 1);

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:51 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
