(function(){var P$=Clazz.newPackage("jalview.datamodel"),I$=[[0,'java.util.BitSet','java.util.Arrays','java.awt.Color','jalview.util.ColorUtils']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*i*/var C$=Clazz.newInterface(P$, "ContactMatrixI");
C$.$defaults$ = function(C$){

Clazz.newMeth(C$, 'hasGroupSet$',  function () {
return this.getGroupSet$() != null ;
});

Clazz.newMeth(C$, 'hasGroups$',  function () {
return this.hasGroupSet$() && this.getGroupSet$().hasGroups$() ;
});

Clazz.newMeth(C$, 'getGroupsFor$I',  function (column) {
if (!this.hasGroupSet$()) {
var colbitset=Clazz.new_($I$(1,1));
colbitset.set$I(column);
return colbitset;
}return this.getGroupSet$().getGroupsFor$I(column);
});

Clazz.newMeth(C$, 'getGroups$',  function () {
if (!this.hasGroupSet$()) {
return $I$(2,"asList$OA",[Clazz.array($I$(1), -1, [])]);
}return this.getGroupSet$().getGroups$();
});

Clazz.newMeth(C$, 'hasTree$',  function () {
return this.hasGroupSet$() ? this.getGroupSet$().hasTree$() : false;
});

Clazz.newMeth(C$, 'getNewick$',  function () {
return this.hasGroupSet$() ? this.getGroupSet$().getNewick$() : null;
});

Clazz.newMeth(C$, 'getTreeMethod$',  function () {
return this.hasGroupSet$() ? this.getGroupSet$().getTreeMethod$() : null;
});

Clazz.newMeth(C$, 'hasCutHeight$',  function () {
return this.hasGroupSet$() ? this.getGroupSet$().hasCutHeight$() : false;
});

Clazz.newMeth(C$, 'getCutHeight$',  function () {
return this.hasGroupSet$() ? this.getGroupSet$().getCutHeight$() : 0;
});

Clazz.newMeth(C$, 'updateGroups$java_util_List',  function (colGroups) {
if (this.hasGroupSet$()) {
this.getGroupSet$().updateGroups$java_util_List(colGroups);
}});

Clazz.newMeth(C$, 'setColorForGroup$java_util_BitSet$java_awt_Color',  function (bs, color) {
if (this.hasGroupSet$()) {
this.getGroupSet$().setColorForGroup$java_util_BitSet$java_awt_Color(bs, color);
}});

Clazz.newMeth(C$, 'getColourForGroup$java_util_BitSet',  function (bs) {
if (this.hasGroupSet$()) {
return this.getGroupSet$().getColourForGroup$java_util_BitSet(bs);
} else {
return $I$(3).white;
}});

Clazz.newMeth(C$, 'randomlyReColourGroups$',  function () {
if (this.hasGroupSet$()) {
var groups=this.getGroupSet$();
for (var group, $group = groups.getGroups$().iterator$(); $group.hasNext$()&&((group=($group.next$())),1);) {
groups.setColorForGroup$java_util_BitSet$java_awt_Color(group, $I$(4).getARandomColor$());
}
}});

Clazz.newMeth(C$, 'transferGroupColorsTo$jalview_datamodel_AlignmentAnnotation',  function (aa) {
if (this.hasGroupSet$()) {
var groups=this.getGroupSet$();
var sstart=aa.sequenceRef != null  ? aa.sequenceRef.getStart$() - 1 : 0;
var ae;
var gpcol=null;
var seqpos=null;
for (var gp, $gp = groups.getGroups$().iterator$(); $gp.hasNext$()&&((gp=($gp.next$())),1);) {
gpcol=groups.getColourForGroup$java_util_BitSet(gp);
for (var p=gp.nextSetBit$I(0); p >= 0 && p < 2147483647 ; p=gp.nextSetBit$I(p + 1)) {
if (Clazz.instanceOf(this, "jalview.ws.datamodel.MappableContactMatrixI")) {
var mcm=this;
seqpos=mcm.getMappedPositionsFor$jalview_datamodel_SequenceI$I(aa.sequenceRef, p);
if (seqpos == null ) {
continue;
}ae=aa.getAnnotationForPosition$I(seqpos[0]);
} else {
ae=aa.getAnnotationForPosition$I(p + sstart);
}if (ae != null ) {
ae.colour=gpcol.brighter$().darker$();
}}
}
}});

Clazz.newMeth(C$, 'getGroupColorForPosition$I',  function (column) {
if (this.hasGroupSet$()) {
var groups=this.getGroupSet$();
for (var gp, $gp = groups.getGroups$().iterator$(); $gp.hasNext$()&&((gp=($gp.next$())),1);) {
if (gp.get$I(column)) {
return groups.getColourForGroup$java_util_BitSet(gp);
}}
}return $I$(3).white;
});
};})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:25:51 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
