(function(){var P$=Clazz.newPackage("jalview.util"),I$=[[0,'java.util.HashMap','java.util.HashSet','java.util.ArrayList','jalview.util.FileUtils',['jalview.util.ArgParserUtils','.BaseInfo'],'jalview.util.HttpUtils','jalview.bin.argparser.Arg','jalview.io.FileFormats','java.util.Locale','jalview.bin.Cache']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "ArgParserUtils", function(){
Clazz.newInstance(this, arguments,0,C$);
});
C$.$classes$=[['BaseInfo',9]];

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[[]
,['O',['alignmentExtensions','java.util.Set','+annotationsExtensions','+featuresExtensions','+treeExtensions','argSet','java.util.List','argExtensionsMap','java.util.Map']]]

Clazz.newMeth(C$, 'preProcessArgs$java_util_List',  function (filenames) {
C$.processFilenames$java_util_List$Z(filenames, true);
}, 1);

Clazz.newMeth(C$, 'processFilenames$java_util_List$Z',  function (filenames, addArgs) {
return C$.processFilenames$java_util_List$Z$java_util_List(filenames, addArgs, null);
}, 1);

Clazz.newMeth(C$, 'processFilenames$java_util_List$Z$java_util_List',  function (filenames, addArgs, files) {
if (C$.alignmentExtensions == null ) {
C$.setValidExtensions$();
}var filesSet=Clazz.new_($I$(2,1).c$$java_util_Collection,[filenames]);
var baseInfoMap=Clazz.new_($I$(1,1));
var filenamesCopy=Clazz.new_($I$(3,1).c$$java_util_Collection,[filenames]);
for (var filename, $filename = filenamesCopy.iterator$(); $filename.hasNext$()&&((filename=($filename.next$())),1);) {
if (filename == null ) {
continue;
}var ext=$I$(4).getExtension$S(filename);
if (ext != null  && ext.length$() > 0  && C$.alignmentExtensions.contains$O(ext) ) {
var bi=Clazz.new_($I$(5,1).c$$S,[filename]);
var base=$I$(4).getBase$S(filename);
for (var arg, $arg = C$.argSet.iterator$(); $arg.hasNext$()&&((arg=($arg.next$())),1);) {
for (var possibleExt, $possibleExt = C$.argExtensionsMap.get$O(arg).iterator$(); $possibleExt.hasNext$()&&((possibleExt=($possibleExt.next$())),1);) {
var possibleFile=base + possibleExt;
if (filesSet.contains$O(possibleFile)) {
bi.putAssociatedFile$jalview_bin_argparser_Arg$S(arg, possibleFile);
var filePos=filenames.indexOf$O(possibleFile);
filenames.remove$O(possibleFile);
if (files != null  && files.get$I(filePos) != null   && possibleFile.equals$O(files.get$I(filePos).toString()) ) {
files.remove$I(filePos);
}break;
}}
}
baseInfoMap.put$O$O(filename, bi);
}}
if (addArgs) {
for (var filename, $filename = baseInfoMap.keySet$().iterator$(); $filename.hasNext$()&&((filename=($filename.next$())),1);) {
var bi=baseInfoMap.get$O(filename);
var pos=filenames.indexOf$O(filename);
if (bi.associatedFiles != null ) {
for (var a, $a = bi.associatedFiles.keySet$().iterator$(); $a.hasNext$()&&((a=($a.next$())),1);) {
var associatedFile=bi.associatedFiles.get$O(a);
if (associatedFile == null ) {
continue;
}filenames.add$I$O(pos + 1, a.argString$());
filenames.add$I$O(pos + 2, $I$(6).equivalentJalviewUrl$S(associatedFile));
}
}filenames.add$I$O(pos, $I$(7).OPEN.argString$());
}
}return baseInfoMap;
}, 1);

Clazz.newMeth(C$, 'setValidExtensions$',  function () {
C$.alignmentExtensions=Clazz.new_($I$(2,1));
var ffs=$I$(8).getInstance$();
var validFormats=ffs.getReadableFormats$();
for (var fname, $fname = validFormats.iterator$(); $fname.hasNext$()&&((fname=($fname.next$())),1);) {
var tff=ffs.forName$S(fname);
var extensions=tff.getExtensions$().split$S(",");
for (var ext, $ext = 0, $$ext = extensions; $ext<$$ext.length&&((ext=($$ext[$ext])),1);$ext++) {
C$.alignmentExtensions.add$O(ext.toLowerCase$java_util_Locale($I$(9).ROOT));
}
}
C$.annotationsExtensions=Clazz.new_($I$(2,1));
for (var ext, $ext = 0, $$ext = $I$(10).getDefault$S$S("ARGPREPROCESSORANNOTATIONSEXTENSIONS", "annotation,annotations,jvannotation,jvannotations,gff,gff2,gff3").split$S(","); $ext<$$ext.length&&((ext=($$ext[$ext])),1);$ext++) {
C$.annotationsExtensions.add$O(ext);
}
C$.featuresExtensions=Clazz.new_($I$(2,1));
for (var ext, $ext = 0, $$ext = $I$(10).getDefault$S$S("ARGPREPROCESSORFEATURESEXTENSIONS", "feature,features,jvfeature,jvfeatures").split$S(","); $ext<$$ext.length&&((ext=($$ext[$ext])),1);$ext++) {
C$.featuresExtensions.add$O(ext);
}
C$.treeExtensions=Clazz.new_($I$(2,1));
for (var ext, $ext = 0, $$ext = $I$(10).getDefault$S$S("ARGPREPROCESSORTREEEXTENSIONS", "tree,tre,newick,nwk").split$S(","); $ext<$$ext.length&&((ext=($$ext[$ext])),1);$ext++) {
C$.treeExtensions.add$O(ext);
}
C$.argSet=Clazz.new_($I$(3,1));
C$.argSet.add$O($I$(7).ANNOTATIONS);
C$.argSet.add$O($I$(7).FEATURES);
C$.argSet.add$O($I$(7).TREE);
C$.argExtensionsMap=Clazz.new_($I$(1,1));
C$.argExtensionsMap.put$O$O($I$(7).ANNOTATIONS, C$.annotationsExtensions);
C$.argExtensionsMap.put$O$O($I$(7).FEATURES, C$.featuresExtensions);
C$.argExtensionsMap.put$O$O($I$(7).TREE, C$.treeExtensions);
}, 1);

C$.$static$=function(){C$.$static$=0;
C$.alignmentExtensions=null;
C$.annotationsExtensions=null;
C$.featuresExtensions=null;
C$.treeExtensions=null;
C$.argSet=null;
C$.argExtensionsMap=null;
};
;
(function(){/*c*/var C$=Clazz.newClass(P$.ArgParserUtils, "BaseInfo", function(){
Clazz.newInstance(this, arguments[0],false,C$);
});

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.associatedFiles=null;
},1);

C$.$fields$=[['S',['filename'],'O',['associatedFiles','java.util.Map']]]

Clazz.newMeth(C$, 'c$$S',  function (filename) {
;C$.$init$.apply(this);
this.filename=filename;
}, 1);

Clazz.newMeth(C$, 'putAssociatedFile$jalview_bin_argparser_Arg$S',  function (a, file) {
if (this.associatedFiles == null ) {
this.associatedFiles=Clazz.new_($I$(1,1));
}this.associatedFiles.put$O$O(a, file);
});

Clazz.newMeth(C$, 'getAssociatedFilesMap$',  function () {
return this.associatedFiles;
});

Clazz.newMeth(C$);
})()

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:26:06 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
