(function(){var P$=Clazz.newPackage("jalview.util"),I$=[[0,'jalview.util.MessageManager','jalview.io.JalviewFileChooser','java.io.FileOutputStream',['jalview.util.ImageMaker','.TYPE'],'javax.imageio.ImageIO','java.awt.image.BufferedImage','java.awt.RenderingHints','org.jfree.graphics2d.svg.SVGGraphics2D','org.jfree.graphics2d.svg.SVGHints','org.jibble.epsgraphics.EpsGraphics2D','jalview.util.imagemaker.BitmapImageSizing','jalview.bin.Console']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "ImageMaker", function(){
Clazz.newInstance(this, arguments,0,C$);
});
C$.$classes$=[['TYPE',25]];

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['O',['pg','org.jibble.epsgraphics.EpsGraphics2D','graphics','java.awt.Graphics','out','java.io.FileOutputStream','bi','java.awt.image.BufferedImage','type','jalview.util.ImageMaker.TYPE']]]

Clazz.newMeth(C$, 'c$$jalview_util_ImageMaker_TYPE$I$I$java_io_File$S$Z$jalview_util_imagemaker_BitmapImageSizing',  function (imageType, width, height, file, fileTitle, useLineart, userBis) {
;C$.$init$.apply(this);
this.type=imageType;
this.out=Clazz.new_($I$(3,1).c$$java_io_File,[file]);
switch (imageType) {
case $I$(4).SVG:
this.setupSVG$I$I$Z(width, height, useLineart);
break;
case $I$(4).EPS:
this.setupEPS$I$I$S$Z(width, height, fileTitle, useLineart);
break;
case $I$(4).PNG:
this.setupPNG$I$I$jalview_util_imagemaker_BitmapImageSizing(width, height, userBis);
break;
default:
}
}, 1);

Clazz.newMeth(C$, 'getGraphics$',  function () {
return this.graphics;
});

Clazz.newMeth(C$, 'writeImage$',  function () {
try {
switch (this.type) {
case $I$(4).EPS:
this.pg.flush$();
this.pg.close$();
break;
case $I$(4).SVG:
var svgData=(this.getGraphics$()).getSVGDocument$();
this.out.write$BA(svgData.getBytes$());
this.out.flush$();
this.out.close$();
break;
case $I$(4).PNG:
$I$(5).write$java_awt_image_RenderedImage$S$java_io_OutputStream(this.bi, "png", this.out);
this.out.flush$();
this.out.close$();
break;
}
} catch (ex) {
if (Clazz.exceptionOf(ex,"Exception")){
ex.printStackTrace$();
} else {
throw ex;
}
}
});

Clazz.newMeth(C$, 'setupPNG$I$I$jalview_util_imagemaker_BitmapImageSizing',  function (width, height, userBis) {
if (width == 0 || height == 0 ) return;
var bis=C$.getScaleWidthHeight$I$I$jalview_util_imagemaker_BitmapImageSizing(width, height, userBis);
var usescale=bis.scale$();
var usewidth=bis.width$();
var useheight=bis.height$();
this.bi=Clazz.new_($I$(6,1).c$$I$I$I,[usewidth, useheight, 1]);
this.graphics=this.bi.getGraphics$();
var ig2=this.graphics;
ig2.setRenderingHint$java_awt_RenderingHints_Key$O($I$(7).KEY_ANTIALIASING, $I$(7).VALUE_ANTIALIAS_ON);
if (usescale > 0.0 ) {
ig2.scale$D$D(usescale, usescale);
}});

Clazz.newMeth(C$, 'setupSVG$I$I$Z',  function (width, height, useLineart) {
var g2=Clazz.new_($I$(8,1).c$$I$I,[width, height]);
if (useLineart) {
g2.setRenderingHint$java_awt_RenderingHints_Key$O($I$(9).KEY_DRAW_STRING_TYPE, $I$(9).VALUE_DRAW_STRING_TYPE_VECTOR);
}this.graphics=g2;
});

Clazz.newMeth(C$, 'setupEPS$I$I$S$Z',  function (width, height, title, useLineart) {
this.pg=Clazz.new_($I$(10,1).c$$S$java_io_OutputStream$I$I$I$I,[title, this.out, 0, 0, width, height]);
var ig2=this.pg;
ig2.setRenderingHint$java_awt_RenderingHints_Key$O($I$(7).KEY_ANTIALIASING, $I$(7).VALUE_ANTIALIAS_ON);
this.pg.setAccurateTextMode$Z(useLineart);
this.graphics=this.pg;
});

Clazz.newMeth(C$, 'getScaleWidthHeight$I$I$F$I$I',  function (width, height, scale, bitmapwidth, bitmapheight) {
var usescale=0.0;
var usewidth=width;
var useheight=height;
if ((width == 0 && bitmapwidth > 0 ) || (height == 0 && bitmapheight > 0 ) ) {
return $I$(11).nullBitmapImageSizing$();
}if (scale > 0.0 ) {
usescale=scale;
usewidth=Math.round(scale * width);
useheight=Math.round(scale * height);
}if (bitmapwidth > 0) {
var wscale=bitmapwidth / width;
if (wscale > 0.0  && (usescale == 0.0  || wscale < usescale  ) ) {
usescale=wscale;
usewidth=bitmapwidth;
useheight=Math.round(usescale * height);
}}if (bitmapheight > 0) {
var hscale=bitmapheight / height;
if (hscale > 0.0  && (usescale == 0.0  || hscale < usescale  ) ) {
usescale=hscale;
usewidth=Math.round(usescale * width);
useheight=bitmapheight;
}}return Clazz.new_($I$(11,1).c$$F$I$I$Z,[usescale, usewidth, useheight, false]);
}, 1);

Clazz.newMeth(C$, 'getScaleWidthHeight$I$I$jalview_util_imagemaker_BitmapImageSizing',  function (width, height, bis) {
return C$.getScaleWidthHeight$I$I$F$I$I(width, height, bis.scale$(), bis.width$(), bis.height$());
}, 1);

Clazz.newMeth(C$, 'parseScaleWidthHeightStrings$S$S$S',  function (scaleS, widthS, heightS) {
if (scaleS == null  && widthS == null   && heightS == null  ) {
return $I$(11).defaultBitmapImageSizing$();
}var scale=0.0;
var width=0;
var height=0;
if (scaleS != null ) {
try {
scale=Float.parseFloat$S(scaleS);
} catch (e) {
if (Clazz.exceptionOf(e,"NumberFormatException")){
$I$(12).warn$S("Did not understand scale '" + scaleS + "', won't be used." );
} else {
throw e;
}
}
}if (widthS != null ) {
try {
width=Integer.parseInt$S(widthS);
} catch (e) {
if (Clazz.exceptionOf(e,"NumberFormatException")){
$I$(12).warn$S("Did not understand width '" + widthS + "', won't be used." );
} else {
throw e;
}
}
}if (heightS != null ) {
try {
height=Integer.parseInt$S(heightS);
} catch (e) {
if (Clazz.exceptionOf(e,"NumberFormatException")){
$I$(12).warn$S("Did not understand height '" + heightS + "', won't be used." );
} else {
throw e;
}
}
}return Clazz.new_($I$(11,1).c$$F$I$I$Z,[scale, width, height, false]);
}, 1);
;
(function(){/*e*/var C$=Clazz.newClass(P$.ImageMaker, "TYPE", function(){
Clazz.newInstance(this, arguments[0],false,C$);
}, 'Enum');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['S',['$name','label','extension','description']]]

Clazz.newMeth(C$, 'c$$S$S$S$S',  function (name, label, ext, desc) {
;C$.$init$.apply(this);
this.$name=name;
this.label=label;
this.extension=ext;
this.description=desc;
}, 1);

Clazz.newMeth(C$, 'getName$',  function () {
return this.$name;
});

Clazz.newMeth(C$, 'getFileChooser$',  function () {
return Clazz.new_($I$(2,1).c$$S$S,[this.extension, this.description]);
});

Clazz.newMeth(C$, 'getLabel$',  function () {
return this.label;
});

C$.$static$=function(){C$.$static$=0;
$vals=Clazz.array(C$,[0]);
Clazz.newEnumConst($vals, C$.c$$S$S$S$S, "EPS", 0, ["EPS", $I$(1).getString$S("label.eps_file"), "eps", "Encapsulated Postscript"]);
Clazz.newEnumConst($vals, C$.c$$S$S$S$S, "PNG", 1, ["PNG", $I$(1).getString$S("label.png_image"), "png", "Portable  network graphics"]);
Clazz.newEnumConst($vals, C$.c$$S$S$S$S, "SVG", 2, ["SVG", "SVG", "svg", "Scalable Vector Graphics"]);
};

Clazz.newMeth(C$);
var $vals=[];
Clazz.newMeth(C$, 'values$', function() { return $vals }, 1);
Clazz.newMeth(C$, 'valueOf$S', function(name) { for (var val in $vals){ if ($vals[val].name == name) return $vals[val]} return null }, 1);
})()

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:26:06 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
