(function(){var P$=Clazz.newPackage("jalview.viewmodel"),I$=[[0,'jalview.analysis.PaSiMap','java.util.Vector','jalview.datamodel.SequencePoint','StringBuffer']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "PaSiMapModel");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.nucleotide=false;
},1);

C$.$fields$=[['Z',['nucleotide'],'I',['top'],'O',['inputData','jalview.viewmodel.AlignmentViewport','seqs','jalview.datamodel.SequenceI[]','scoreModel','jalview.api.analysis.ScoreModelI','pasimap','jalview.analysis.PaSiMap','points','java.util.List']]]

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_SequenceIA$Z$jalview_api_analysis_ScoreModelI',  function (seqData, sqs, nuc, modelName) {
;C$.$init$.apply(this);
this.inputData=seqData;
this.seqs=sqs;
this.nucleotide=nuc;
this.scoreModel=modelName;
}, 1);

Clazz.newMeth(C$, 'calculate$jalview_gui_PairwiseAlignPanel',  function (pap) {
this.pasimap=Clazz.new_($I$(1,1).c$$jalview_viewmodel_AlignmentViewport$jalview_api_analysis_ScoreModelI$jalview_gui_PairwiseAlignPanel,[this.inputData, this.scoreModel, pap]);
this.pasimap.run$();
if (this.pasimap.isCancelled$()) {
return;
}var ii=0;
while ((ii < this.seqs.length) && (this.seqs[ii] != null ) ){
++ii;
}
var width=this.pasimap.getWidth$();
var height=this.pasimap.getHeight$();
this.top=width;
this.points=Clazz.new_($I$(2,1));
var scores=this.pasimap.getComponents$I$I$I$F(width - 1, width - 2, width - 3, 1);
for (var i=0; i < height; i++) {
var sp=Clazz.new_($I$(3,1).c$$jalview_datamodel_SequenceI$jalview_datamodel_Point,[this.seqs[i], scores[i]]);
this.points.add$O(sp);
}
});

Clazz.newMeth(C$, 'updateRc$jalview_api_RotatableCanvasI',  function (rc) {
rc.setPoints$java_util_List$I(this.points, this.pasimap.getHeight$());
});

Clazz.newMeth(C$, 'isNucleotide$',  function () {
return this.nucleotide;
});

Clazz.newMeth(C$, 'setNucleotide$Z',  function (nucleotide) {
this.nucleotide=nucleotide;
});

Clazz.newMeth(C$, 'getTop$',  function () {
return this.top;
});

Clazz.newMeth(C$, 'setTop$I',  function (t) {
this.top=t;
});

Clazz.newMeth(C$, 'updateRcView$I$I$I',  function (dim1, dim2, dim3) {
var scores=this.pasimap.getComponents$I$I$I$F(dim1 - 1, dim2 - 1, dim3 - 1, 1);
for (var i=0; i < this.pasimap.getHeight$(); i++) {
this.points.get$I(i).coord=scores[i];
}
});

Clazz.newMeth(C$, 'getDetails$',  function () {
return this.pasimap.getDetails$();
});

Clazz.newMeth(C$, 'getAlignmentOutput$',  function () {
return this.pasimap.getAlignmentOutput$();
});

Clazz.newMeth(C$, 'getInputData$',  function () {
return this.inputData;
});

Clazz.newMeth(C$, 'setInputData$jalview_viewmodel_AlignmentViewport',  function (data) {
this.inputData=data;
});

Clazz.newMeth(C$, 'getPointsasCsv$Z$I$I$I',  function (transformed, xdim, ydim, zdim) {
var csv=Clazz.new_($I$(4,1));
csv.append$S("\"Sequence\"");
if (transformed) {
csv.append$S(",");
csv.append$I(xdim);
csv.append$S(",");
csv.append$I(ydim);
csv.append$S(",");
csv.append$I(zdim);
} else {
for (var d=1, dmax=(this.pasimap.getDim$()|0); d <= dmax; d++) {
csv.append$S("," + d);
}
}csv.append$S("\n");
for (var s=0; s < this.seqs.length; s++) {
csv.append$S("\"" + this.seqs[s].getName$() + "\"" );
if (!transformed) {
var fl=this.pasimap.component$I(s);
for (var d=fl.length - 1; d >= 0; d--) {
csv.append$S(",");
csv.append$D(fl[d]);
}
} else {
var p=this.points.get$I(s).coord;
csv.append$S(",").append$F(p.x);
csv.append$S(",").append$F(p.y);
csv.append$S(",").append$F(p.z);
}csv.append$S("\n");
}
return csv.toString();
});

Clazz.newMeth(C$, 'getScoreModelName$',  function () {
return this.scoreModel == null  ? "" : this.scoreModel.getName$();
});

Clazz.newMeth(C$, 'setScoreModel$jalview_api_analysis_ScoreModelI',  function (sm) {
this.scoreModel=sm;
});

Clazz.newMeth(C$, 'getSequencePoints$',  function () {
return this.points;
});

Clazz.newMeth(C$, 'setSequencePoints$java_util_List',  function (sp) {
this.points=sp;
});

Clazz.newMeth(C$, 'getPasimapData$',  function () {
return this.pasimap;
});

Clazz.newMeth(C$, 'setPaSiMap$jalview_analysis_PaSiMap',  function (data) {
this.pasimap=data;
});

Clazz.newMeth(C$, 'isCancelled$',  function () {
if (this.pasimap == null  || this.pasimap.isCancelled$() ) {
return true;
}return false;
});

Clazz.newMeth(C$, 'cancel$',  function () {
this.pasimap.cancel$();
});

Clazz.newMeth(C$, 'canCancel$',  function () {
return (!this.isCancelled$() && this.pasimap.isCancellable$() );
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:26:07 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
