(function(){var P$=Clazz.newPackage("jalview.workers"),I$=[[0,'Thread','jalview.datamodel.Annotation','jalview.analysis.AAFrequency']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "SecondaryStructureConsensusThread", null, 'jalview.workers.AlignCalcWorker');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

Clazz.newMeth(C$, 'c$$jalview_api_AlignViewportI$jalview_api_AlignmentViewPanel',  function (alignViewport, alignPanel) {
;C$.superclazz.c$$jalview_api_AlignViewportI$jalview_api_AlignmentViewPanel.apply(this,[alignViewport, alignPanel]);C$.$init$.apply(this);
}, 1);

Clazz.newMeth(C$, 'run$',  function () {
if (this.calcMan.isPending$jalview_api_AlignCalcWorkerI(this)) {
return;
}this.calcMan.notifyStart$jalview_api_AlignCalcWorkerI(this);
try {
var ssConsensus=this.getSSConsensusAnnotation$();
if ((ssConsensus == null ) || this.calcMan.isPending$jalview_api_AlignCalcWorkerI(this) ) {
this.calcMan.workerComplete$jalview_api_AlignCalcWorkerI(this);
return;
}while (!this.calcMan.notifyWorking$jalview_api_AlignCalcWorkerI(this)){
try {
if (this.ap != null ) {
this.ap.paintAlignment$Z$Z(false, false);
}$I$(1).sleep$J(200);
} catch (ex) {
if (Clazz.exceptionOf(ex,"Exception")){
ex.printStackTrace$();
} else {
throw ex;
}
}
}
if (this.alignViewport.isClosed$()) {
this.abortAndDestroy$();
return;
}var alignment=this.alignViewport.getAlignment$();
var aWidth=-1;
if (alignment == null  || (aWidth=alignment.getWidth$()) < 0 ) {
this.calcMan.workerComplete$jalview_api_AlignCalcWorkerI(this);
return;
}this.eraseSSConsensus$I(aWidth);
this.computeSSConsensus$jalview_datamodel_AlignmentI(alignment);
this.updateResultAnnotation$Z(true);
if (this.ap != null ) {
this.ap.paintAlignment$Z$Z(true, true);
}} catch (error) {
if (Clazz.exceptionOf(error,"OutOfMemoryError")){
this.calcMan.disableWorker$jalview_api_AlignCalcWorkerI(this);
this.ap.raiseOOMWarning$S$OutOfMemoryError("calculating consensus", error);
} else {
throw error;
}
} finally {
this.calcMan.workerComplete$jalview_api_AlignCalcWorkerI(this);
}
});

Clazz.newMeth(C$, 'eraseSSConsensus$I',  function (aWidth) {
var ssConsensus=this.getSSConsensusAnnotation$();
if (ssConsensus != null ) {
ssConsensus.annotations=Clazz.array($I$(2), [aWidth]);
}});

Clazz.newMeth(C$, 'computeSSConsensus$jalview_datamodel_AlignmentI',  function (alignment) {
var aseqs=this.getSequences$();
var width=alignment.getWidth$();
var hSSConsensus=$I$(3).calculateSS$jalview_datamodel_SequenceIA$I$I$I$Z(aseqs, width, 0, width, true);
this.alignViewport.setSequenceSSConsensusHash$jalview_datamodel_ProfilesI(hSSConsensus);
this.setColourSchemeConsensus$jalview_datamodel_ProfilesI(hSSConsensus);
});

Clazz.newMeth(C$, 'getSequences$',  function () {
return this.alignViewport.getAlignment$().getSequencesArray$();
});

Clazz.newMeth(C$, 'setColourSchemeConsensus$jalview_datamodel_ProfilesI',  function (hSSconsensus) {
var cs=this.alignViewport.getResidueShading$();
if (cs != null ) {
cs.setSsConsensus$jalview_datamodel_ProfilesI(hSSconsensus);
}});

Clazz.newMeth(C$, 'getSSConsensusAnnotation$',  function () {
return this.alignViewport.getAlignmentSecondaryStructureConsensusAnnotation$();
});

Clazz.newMeth(C$, 'updateAnnotation$',  function () {
this.updateResultAnnotation$Z(false);
});

Clazz.newMeth(C$, 'updateResultAnnotation$Z',  function (immediate) {
var ssConsensus=this.getSSConsensusAnnotation$();
var hSSConsensus=this.getViewportSSConsensus$();
if (immediate || !this.calcMan.isWorking$jalview_api_AlignCalcWorkerI(this) && ssConsensus != null   && hSSConsensus != null   ) {
this.deriveSSConsensus$jalview_datamodel_AlignmentAnnotation$jalview_datamodel_ProfilesI(ssConsensus, hSSConsensus);
ssConsensus.hasData=hSSConsensus.getCount$() > 0;
}});

Clazz.newMeth(C$, 'deriveSSConsensus$jalview_datamodel_AlignmentAnnotation$jalview_datamodel_ProfilesI',  function (ssConsensusAnnotation, hSSConsensus) {
var nseq=this.getSequences$().length;
$I$(3,"completeSSConsensus$jalview_datamodel_AlignmentAnnotation$jalview_datamodel_ProfilesI$I$I$Z$Z$J",[ssConsensusAnnotation, hSSConsensus, hSSConsensus.getStartColumn$(), hSSConsensus.getEndColumn$() + 1, this.alignViewport.isIgnoreGapsConsensus$(), this.alignViewport.isShowSequenceLogo$(), nseq]);
});

Clazz.newMeth(C$, 'getViewportSSConsensus$',  function () {
return this.alignViewport.getSequenceSSConsensusHash$();
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:26:07 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
