(function(){var P$=Clazz.newPackage("jalview.ws.datamodel.alphafold"),p$1={},I$=[[0,'jalview.util.MapUtils','jalview.datamodel.FloatContactMatrix','StringBuilder','java.io.FileInputStream','java.io.File','jalview.ws.dbsources.EBIAlfaFold','jalview.datamodel.SequenceDummy']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "PAEContactMatrix", null, 'jalview.ws.datamodel.alphafold.MappableContactMatrix', 'jalview.datamodel.ContactMatrixI');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

Clazz.newMeth(C$, 'c$$jalview_datamodel_SequenceI$java_util_Map',  function (_refSeq, pae_obj) {
Clazz.super_(C$, this);
this.setRefSeq$jalview_datamodel_SequenceI(_refSeq);
if (!$I$(1,"containsAKey$java_util_Map$OA",[pae_obj, Clazz.array(String, -1, ["predicted_aligned_error", "pae"])])) {
p$1.parse_version_1_pAE$java_util_Map.apply(this, [pae_obj]);
return;
} else {
p$1.parse_version_2_pAE$java_util_Map.apply(this, [pae_obj]);
}}, 1);

Clazz.newMeth(C$, 'c$$jalview_datamodel_SequenceI$FAA',  function (_refSeq, matrix) {
Clazz.super_(C$, this);
this.mappedMatrix=Clazz.new_($I$(2,1).c$$FAA,[matrix]);
this.setRefSeq$jalview_datamodel_SequenceI(_refSeq);
}, 1);

Clazz.newMeth(C$, 'c$$jalview_datamodel_SequenceI$jalview_util_MapList$FAA$jalview_datamodel_GroupSet',  function (newRefSeq, newFromMapList, elements2, grps2) {
C$.c$$jalview_datamodel_SequenceI$jalview_datamodel_ContactMatrixI.apply(this, [newRefSeq, Clazz.new_($I$(2,1).c$$FAA$jalview_datamodel_GroupSet,[elements2, grps2])]);
this.toSeq=newFromMapList;
}, 1);

Clazz.newMeth(C$, 'c$$jalview_datamodel_SequenceI$jalview_datamodel_ContactMatrixI',  function (_refSeq, floatContactMatrix) {
Clazz.super_(C$, this);
this.mappedMatrix=floatContactMatrix;
this.setRefSeq$jalview_datamodel_SequenceI(_refSeq);
}, 1);

Clazz.newMeth(C$, 'c$$jalview_datamodel_SequenceI$jalview_util_MapList$jalview_datamodel_ContactMatrixI',  function (_refSeq, newFromMapList, floatContactMatrix) {
Clazz.super_(C$, this);
this.mappedMatrix=floatContactMatrix;
this.setRefSeq$jalview_datamodel_SequenceI(_refSeq);
this.toSeq=newFromMapList;
}, 1);

Clazz.newMeth(C$, 'newMappableContactMatrix$jalview_datamodel_SequenceI$jalview_util_MapList',  function (newRefSeq, newFromMapList) {
return Clazz.new_(C$.c$$jalview_datamodel_SequenceI$jalview_util_MapList$jalview_datamodel_ContactMatrixI,[newRefSeq, newFromMapList, this.mappedMatrix]);
});

Clazz.newMeth(C$, 'parse_version_2_pAE$java_util_Map',  function (pae_obj) {
var maxscore=-1;
try {
maxscore=($I$(1,"getFirst$java_util_Map$OA",[pae_obj, Clazz.array(String, -1, ["max_predicted_aligned_error", "max_pae"])])).floatValue$();
} catch (t) {
}
var scoreRows=($I$(1,"getFirst$java_util_Map$OA",[pae_obj, Clazz.array(String, -1, ["predicted_aligned_error", "pae"])]));
var elements=Clazz.array(Float.TYPE, [scoreRows.size$(), scoreRows.size$()]);
var row=0;
var col=0;
for (var scoreRow, $scoreRow = scoreRows.iterator$(); $scoreRow.hasNext$()&&((scoreRow=($scoreRow.next$())),1);) {
var scores=scoreRow.iterator$();
while (scores.hasNext$()){
var d=scores.next$();
if (Clazz.instanceOf(d, "java.lang.Double")) {
elements[col][row]=Long.$fval((d).longValue$());
} else {
elements[col][row]=Long.$fval((d).longValue$());
}if (maxscore < elements[col][row] ) {
maxscore=elements[col][row];
}++col;
}
++row;
col=0;
}
this.mappedMatrix=Clazz.new_($I$(2,1).c$$FAA,[elements]);
}, p$1);

Clazz.newMeth(C$, 'parse_version_1_pAE$java_util_Map',  function (pae_obj) {
var rows=(pae_obj.get$O("residue1")).iterator$();
var cols=(pae_obj.get$O("residue2")).iterator$();
var maxrow=-1;
var maxcol=-1;
while (rows.hasNext$()){
var row=rows.next$().intValue$();
var col=cols.next$().intValue$();
if (maxrow < row) {
maxrow=row;
}if (maxcol < col) {
maxcol=col;
}}
rows=(pae_obj.get$O("residue1")).iterator$();
cols=(pae_obj.get$O("residue2")).iterator$();
var scores=(pae_obj.get$O("distance")).iterator$();
var elements=Clazz.array(Float.TYPE, [maxcol, maxrow]);
while (scores.hasNext$()){
var escore=scores.next$().floatValue$();
var row=rows.next$().intValue$();
var col=cols.next$().intValue$();
if (maxrow < row) {
maxrow=row;
}if (maxcol < col) {
maxcol=col;
}elements[col - 1][row - 1]=escore;
}
this.mappedMatrix=Clazz.new_($I$(2,1).c$$FAA,[elements]);
}, p$1);

Clazz.newMeth(C$, 'getAnnotDescr$',  function () {
return "Predicted Alignment Error" + ((this.refSeq == null ) ? "" : (" for " + this.refSeq.getName$()));
});

Clazz.newMeth(C$, 'getAnnotLabel$',  function () {
var label=Clazz.new_($I$(3,1).c$$S,["PAE Matrix"]);
return label.toString();
});

Clazz.newMeth(C$, 'getType$',  function () {
return "PAE_MATRIX";
});

Clazz.newMeth(C$, 'validateContactMatrixFile$S',  function (fileName) {
var infile=null;
try {
infile=Clazz.new_([Clazz.new_($I$(5,1).c$$S,[fileName])],$I$(4,1).c$$java_io_File);
} catch (t) {
Clazz.new_(Clazz.load('java.io.IOException').c$$S$Throwable,["Couldn't open " + fileName, t]);
}
var paeDict=null;
try {
paeDict=$I$(6).parseJSONtoPAEContactMatrix$java_io_InputStream(infile);
} catch (t) {
Clazz.new_(Clazz.load('jalview.io.FileFormatException').c$$S,["Couldn't parse " + fileName + " as a JSON dict or array containing a dict" ]);
}
var matrix=Clazz.new_(C$.c$$jalview_datamodel_SequenceI$java_util_Map,[Clazz.new_($I$(7,1).c$$S,["Predicted"]), paeDict]);
if (matrix.getWidth$() <= 0) {
throw Clazz.new_(Clazz.load('jalview.io.FileFormatException').c$$S,["No data in PAE matrix read from '" + fileName + "'" ]);
}}, 1);

Clazz.newMeth(C$, 'equals$O',  function (obj) {
return C$.superclazz.prototype.equals$O.apply(this, [obj]);
});

Clazz.newMeth(C$, 'hashCode$',  function () {
return C$.superclazz.prototype.hashCode$.apply(this, []);
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 18:26:07 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
